//speed share function

freeslot(
"sfx_dshare"
)

//local variables
local dashmodeshare = 0

local function speedshare(special, toucher)
	local player = toucher.player
	local mo = toucher.mo

	//bot check
	if player.bot
		return true
	end
	if not (player.charflags & SF_DASHMODE)
		if (player.dashmodeshare <= 0) or (player.dashmodeshare == nil)
			//share dashmode!
			player.dashmodeshare = 1
			player.charflags = $|SF_DASHMODE
			player.dashmode = (3*TICRATE)+8
			S_StartSound(player.mo, sfx_dshare)
			//particle setup -- ALSO NEVERMIND LOL
			local fxmsonicSPDT = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPDT)
			fxmsonicSPDT.color = player.mo.color
			fxmsonicSPDT.scale = FRACUNIT
			fxmsonicSPDT.momx = player.mo.momx
			fxmsonicSPDT.momy = player.mo.momy
			fxmsonicSPDT.momz = player.mo.momz
			//local fxspeedshare = P_SpawnMobj(mo.x+FixedMul((P_RandomRange(-24, 24)*FRACUNIT), cos(mo.angle+ANGLE_90)), mo.y+FixedMul((P_RandomRange(-24, 24)*FRACUNIT), sin(mo.angle+ANGLE_90)), mo.z-(P_RandomRange(4, 12)*P_MobjFlip(mo))*FRACUNIT, MT_DCHS)
			//fxspeedshare.color = mo.color
			//fxspeedshare.scale = $/2
			//fxspeedshare.destscale = $/P_RandomRange(1,2)
			//fxspeedshare.scalespeed = mo.scale/P_RandomRange(4,8)
			//fxspeedshare.eflags = mo.eflags & MFE_VERTICALFLIP
			//fxspeedshare.momx, fxspeedshare.momy = mo.momx, mo.momy
			//P_SetObjectMomZ(fxspeedshare, 160)
			S_StartMusicCaption("Turbulence Catch", 525, player)
		end
	end
	return true
end

NeoSonic.DashShareThink = function(player)
	if player.dashmodeshare == nil then
		player.dashmodeshare = 0
	end
	//vfx setup for shared players
	if player.dashmodeshare == 1
		if (leveltime%4 == 0)
			local fxdashmodeshareAI = P_SpawnGhostMobj(player.mo)//P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and player.mo.height - 32*player.mo.scale or 0), MT_THOK)
			fxdashmodeshareAI.tics = 5
			fxdashmodeshareAI.color = player.mo.color
			fxdashmodeshareAI.colorized = true
			fxdashmodeshareAI.fuse = 4
			fxdashmodeshareAI.frame = ($1 & ~FF_TRANSMASK)|FF_FULLBRIGHT|FF_TRANS40
			fxdashmodeshareAI.eflags = player.mo.eflags & MFE_VERTICALFLIP
		end
		//testing to see if this follows the player
		if (fxmsonicSPDT) and (fxmsonicSPDT ~= nil)
			fxmsonicSPDT.momx = player.mo.momx
			fxmsonicSPDT.momy = player.mo.momy
			fxmsonicSPDT.momz = player.mo.momz
		end
	end
	//if we go below, remove the shared dashmode
	if player.dashmodeshare == 1 and player.dashmode < (3*TICRATE) then
		player.dashmode = 0
		player.dashmodeshare = 0
		player.charflags = $ & ~SF_DASHMODE
	end
end

//SPEED SHARE TOUCHSPECIAL
addHook ("TouchSpecial", speedshare, MT_DASHMODEASSIST)