freeslot(
	"SPR_MSBO",
	"MT_MSSBOOM",
	"S_MSSBOOM",
	"S_MSSBOOM2",
	"S_MSSBOOM3",
	"S_MSSBOOM4",
	"S_MSSBOOM5",
	"SPR_MSWV",
	"MT_MSWAVE",
	"S_MSWAVE1",
	"S_MSWAVE2",
	"S_MSWAVE3",
	"S_MSWAVE4",
	"S_MSWAVE5",
	"SPR_MSFS",
	"MT_MSFS",
	"S_MSFS1",
	"S_MSFS2",
	"S_MSFS3",
	"S_MSFS4",
	"S_MSFS5",
	"SPR_JUPT",
	"MT_JUPT",
	"S_JUPT1",
	"S_JUPT2",
	"S_JUPT3",
	"S_JUPT4",
	"S_JUPT5",
	"SPR_BSMD",
	"MT_MSBSMDL",
	"S_MSBSMDL",
	"SPR_MHTK",
	"MT_MHTK",
	"MT_MHTKBIG",
	"S_MHTK",
	"SPR_MHTT",
	"S_MHTK2",
	"S_MHTK3",
	"S_MHTK4",
	"S_MHTKBIG",
	"S_MHTKBIG2",
	"S_MHTKBIG3",
	"S_MHTKBIG4",
	"S_MHTKBIG5",
	"S_MHTKBIG6",
	"S_MHTKBIG7",
	"SPR_MJBK",
	"MT_MJBK",
	"S_MJBK",
	"SPR_MJBT",
	"S_MJBK2",
	"S_MJBK3",
	"S_MJBK4",
	"SPR_MHTW",
	"MT_MHTW",
	"S_MHTW",
	"SPR_MTBM",
	"MT_MTBM",
	"S_MTBM1",
	"S_MTBM2",
	"S_MTBM3",
	"S_MTBM4",
	"S_MTBM5",
	"SPR_MHTS",
	"MT_MHTS",
	"S_MHTS",
	"SPR_MSGS",
	"MT_MSGS",
	"S_MSGS",
	"SPR_MSHS",
	"MT_MSHS",
	"S_MSHS",
	"SPR_MPAR",
	"MT_MPAR",
	"S_MPAR",
	"SPR_MSTR",
	"MT_MSTR",
	"S_MSTR",
	"SPR_MHIT",
	"MT_MHIT",
	"S_MHIT",
	"SPR_MSMO",
	"MT_MSMO",
	"S_MSMO",
	"S_MSMO2",
	"S_MSMO3",
	"SPR_HTRL",
	"MT_HTRL",
	"S_HTRL",
	"S_HTRL2",
	"S_HTRL3",
	"S_HTRL4",
	"S_HTRL5",
	"S_HTRL6",
	"SPR_CDAS",
	"SPR_DCHR",
	"MT_DCHR",
	"S_DCHR1",
	"S_DCHR2",
	"S_DCHR3",
	"S_DCHR4",
	"S_DCHR5",
	"SPR_DCHS",
	"MT_DCHS",
	"S_DCHS1",
	"S_DCHS2",
	"S_DCHS3",
	"S_DCHS4",
	"S_DCHS5",
	"SPR_DDSP",
	"MT_DDSP",
	"S_DDSP",
	"SPR_HSPK",
	"sfx_sshpop",
	"sfx_neolck",
	"MT_THKC",
	"SPR_THKC",
	"S_THKC1",
	"S_THKC2",
	"S_THKC3",
	"S_THKC4",
	"S_THKC5",
	"S_THKC6",
	"S_THKC7",
	"S_THKC8",
	"SPR_DMSP",
	"MT_DMWV",
	"S_DMWV1",
	"S_DMWV2",
	"S_DMWV3",
	"S_DMWV4",
	"SPR_SPDT",
	"MT_SPDT",
	"S_SPDT1"
)

// Custom Lockon Object
freeslot("SPR_MRET", "S_MSON_MLOCK", "SPR_MRTW", "S_MSON_MLKW", "SPR_MRTS", "S_MSON_MLKS")
states[S_MSON_MLOCK] = {SPR_MRET, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
states[S_MSON_MLKW] = {SPR_MRTW, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}
states[S_MSON_MLKS] = {SPR_MRTS, FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

//LITERALLY EVERYTHING ELSE
mobjinfo[MT_MSSBOOM] = {
	doomednum = -1,
	spawnstate = S_MSSBOOM,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MSSBOOM] = {
	sprite = SPR_MSBO,
	frame = TR_TRANS60|FF_FULLBRIGHT|A,
	tics = 6,
	nextstate = S_MSSBOOM2
}

states[S_MSSBOOM2] = {
	sprite = SPR_MSBO,
	frame = TR_TRANS20|FF_FULLBRIGHT|A,
	tics = 5,
	nextstate = S_MSSBOOM3
}

states[S_MSSBOOM3] = {
	sprite = SPR_MSBO,
	frame = FF_FULLBRIGHT|A,
	tics = 4,
	nextstate = S_MSSBOOM4
}

states[S_MSSBOOM4] = {
	sprite = SPR_MSBO,
	frame = TR_TRANS20|FF_FULLBRIGHT|A,
	tics = 3,
	nextstate = S_MSSBOOM5
}
states[S_MSSBOOM5] = {
	sprite = SPR_MSBO,
	frame = TR_TRANS60|FF_FULLBRIGHT|A,
	tics = 2,
	nextstate = S_DEATHSTATE
}

//UH THIS MIGHT BE THE SONIC BOOM THING BUT IM GONNA REPLACE IT ANYWAY
mobjinfo[MT_MTBM] = {
	doomednum = -1,
	spawnstate = S_MTBM1,
	flags = MF_NOCLIP|MF_SCENERY
}
//
states[S_MTBM1] = {SPR_HSPK,FF_ADD|FF_ANIMATE,6,nil,1,1,S_DEATHSTATE}
//
mobjinfo[MT_MSWAVE] = {
	doomednum = -1,
	spawnstate = S_MSWAVE1,
	flags = MF_NOCLIP|MF_SCENERY
}

//states[S_MSWAVE1] = {SPR_MSWV,FF_PAPERSPRITE,1,nil,1,1,S_MSWAVE2}

states[S_MSWAVE1] = {
	sprite = SPR_MSWV,
	frame = TR_TRANS20|FF_PAPERSPRITE|A,
	tics = 1,
	nextstate = S_MSWAVE2
}
states[S_MSWAVE2] = {
	sprite = SPR_MSWV,
	frame = TR_TRANS30|FF_PAPERSPRITE|B,
	tics = 1,
	nextstate = S_MSWAVE3
}
states[S_MSWAVE3] = {
	sprite = SPR_MSWV,
	frame = TR_TRANS40|FF_PAPERSPRITE|C,
	tics = 1,
	nextstate = S_MSWAVE4
}
states[S_MSWAVE4] = {
	sprite = SPR_MSWV,
	frame = TR_TRANS60|FF_PAPERSPRITE|D,
	tics = 2,
	nextstate = S_MSWAVE5
}
states[S_MSWAVE5] = {
	sprite = SPR_MSWV,
	frame = TR_TRANS80|FF_PAPERSPRITE|E,
	tics = 3,
	nextstate = S_DEATHSTATE
}

//DASHMODE SIDE WAVES
mobjinfo[MT_DMWV] = {
	doomednum = -1,
	spawnstate = S_DMWV1,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_DMWV1] = {SPR_DMSP,FF_ANIMATE,110,nil,11,1,S_DMWV2}
states[S_DMWV2] = {SPR_DMSP,TR_TRANS30|FF_ANIMATE,8,nil,4,4,S_DMWV3}
states[S_DMWV3] = {SPR_DMSP,TR_TRANS50|FF_ANIMATE,8,nil,4,4,S_DMWV4}
states[S_DMWV4] = {SPR_DMSP,TR_TRANS80|FF_ANIMATE,8,nil,4,4,S_DEATHSTATE}

//SPEED TRANSFER SPARK
mobjinfo[MT_SPDT] = {
	doomednum = -1,
	spawnstate = S_SPDT1,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_SPDT1] = {SPR_SPDT,FF_ANIMATE,28,nil,24,2,S_DEATHSTATE}
//thok circle papersprite thingy

mobjinfo[MT_THKC] = {
	doomednum = -1,
	spawnstate = S_THKC1,
	flags = MF_NOCLIP|MF_SCENERY
}
//states
states[S_THKC1] = {
	sprite = SPR_THKC,
	frame = TR_TRANS40|FF_PAPERSPRITE|A,
	tics = 1,
	nextstate = S_THKC2
}
states[S_THKC2] = {
	sprite = SPR_THKC,
	frame = TR_TRANS30|FF_PAPERSPRITE|B,
	tics = 1,
	nextstate = S_THKC3
}
states[S_THKC3] = {
	sprite = SPR_THKC,
	frame = TR_TRANS20|FF_PAPERSPRITE|C,
	tics = 1,
	nextstate = S_THKC4
}
states[S_THKC4] = {
	sprite = SPR_THKC,
	frame = TR_TRANS10|FF_PAPERSPRITE|D,
	tics = 2,
	nextstate = S_THKC5
}
states[S_THKC5] = {
	sprite = SPR_THKC,
	frame = TR_TRANS20|FF_PAPERSPRITE|E,
	tics = 1,
	nextstate = S_THKC6
}
states[S_THKC6] = {
	sprite = SPR_THKC,
	frame = TR_TRANS40|FF_PAPERSPRITE|F,
	tics = 1,
	nextstate = S_THKC7
}
states[S_THKC7] = {
	sprite = SPR_THKC,
	frame = TR_TRANS60|FF_PAPERSPRITE|G,
	tics = 1,
	nextstate = S_THKC8
}
states[S_THKC8] = {
	sprite = SPR_THKC,
	frame = TR_TRANS80|FF_PAPERSPRITE|H,
	tics = 1,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_MSFS] = {
	doomednum = -1,
	spawnstate = S_MSFS1,
	flags = MF_NOCLIP|MF_SCENERY
}

mobjinfo[MT_MSGS] = {
	doomednum = -1,
	spawnstate = S_MSGS,
	flags = MF_NOCLIP|MF_SCENERY
}

mobjinfo[MT_MSHS] = {
	doomednum = -1,
	spawnstate = S_MSHS,
	flags = MF_NOCLIP|MF_SCENERY
}

//states[S_MSFS1] = {
//	sprite = SPR_MSFS,
//	frame = TR_TRANS30|FF_PAPERSPRITE|FF_ANIMATE|A,
//	tics = 10,
//	nextstate = S_DEATHSTATE
//}

states[S_MSFS1] = {SPR_MSFS,TR_TRANS20|FF_PAPERSPRITE|FF_ANIMATE,10,nil,2,2,S_DEATHSTATE}
states[S_MSGS] = {SPR_MSGS,TR_TRANS20|FF_PAPERSPRITE|FF_ANIMATE,10,nil,2,2,S_DEATHSTATE}
states[S_MSHS] = {SPR_MSHS,TR_TRANS20|FF_PAPERSPRITE|FF_ANIMATE,10,nil,2,2,S_DEATHSTATE}

states[S_MSFS2] = {
	sprite = SPR_MSFS,
	frame = TR_TRANS30|FF_PAPERSPRITE|B,
	tics = 2,
	nextstate = S_MSFS3
}

states[S_MSFS3] = {
	sprite = SPR_MSFS,
	frame = TR_TRANS30|FF_PAPERSPRITE|C,
	tics = 2,
	nextstate = S_MSFS4
}

states[S_MSFS4] = {
	sprite = SPR_MSFS,
	frame = TR_TRANS30|FF_PAPERSPRITE|D,
	tics = 2,
	nextstate = S_MSFS5
}

states[S_MSFS5] = {
	sprite = SPR_MSFS,
	frame = TR_TRANS30|FF_PAPERSPRITE|E,
	tics = 2,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_MSBSMDL] = {
	doomednum = -1,
	spawnstate = S_MSBSMDL,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MSBSMDL] = {
	sprite = SPR_BSMD,
	frame = TR_TRANS50|FF_PAPERSPRITE|A,
	tics = 4,
	nextstate = S_DEATHSTATE
}

//STRONG HOMING ATTACK TRAIL
mobjinfo[MT_HTRL] = {
	doomednum = -1,
	spawnstate = S_HTRL,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_HTRL] = {SPR_HTRL,FF_ADD|A,2,nil,1,1,S_HTRL2}
states[S_HTRL2] = {SPR_HTRL,FF_ADD|B,2,nil,1,1,S_HTRL3}
states[S_HTRL3] = {SPR_HTRL,FF_ADD|C,2,nil,1,1,S_HTRL4}
states[S_HTRL4] = {SPR_HTRL,FF_ADD|D,2,nil,1,1,S_HTRL5}
states[S_HTRL5] = {SPR_HTRL,FF_ADD|E,2,nil,1,1,S_HTRL6}
states[S_HTRL6] = {SPR_HTRL,FF_ADD|F,2,nil,1,1,S_DEATHSTATE}

//STRONG HOMING ATTACK STARS
mobjinfo[MT_MPAR] = {
	doomednum = -1,
	spawnstate = S_MPAR,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MPAR] = {
	sprite = SPR_MPAR,
	tics = 24,
	nextstate = S_DEATHSTATE
}

states[S_MPAR] = {SPR_MPAR,FF_ADD,24,nil,1,1,S_DEATHSTATE}

mobjinfo[MT_MSTR] = {
	doomednum = -1,
	spawnstate = S_MSTR,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MSTR] = {SPR_MSTR,FF_ADD|FF_ANIMATE,24,nil,2,2,S_DEATHSTATE}

//DROP DASH CHARGE
mobjinfo[MT_DCHR] = {
	doomednum = -1,
	spawnstate = S_DCHR1,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_DCHR1] = {SPR_DCHR,TR_TRANS80|A,1,nil,1,1,S_DCHR2}
states[S_DCHR2] = {SPR_DCHR,TR_TRANS50|B,1,nil,1,1,S_DCHR3}
states[S_DCHR3] = {SPR_DCHR,TR_TRANS30|C,1,nil,1,1,S_DCHR4}
states[S_DCHR4] = {SPR_DCHR,D,1,nil,1,1,S_DCHR5}
states[S_DCHR5] = {SPR_DCHR,E,1,nil,1,1,S_DEATHSTATE}

mobjinfo[MT_DCHS] = {
	doomednum = -1,
	spawnstate = S_DCHS1,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_DCHS1] = {SPR_DCHS,A,1,nil,1,1,S_DCHS2}
states[S_DCHS2] = {SPR_DCHS,B,1,nil,1,1,S_DCHS3}
states[S_DCHS3] = {SPR_DCHS,C,1,nil,1,1,S_DCHS4}
states[S_DCHS4] = {SPR_DCHS,TR_TRANS40|D,1,nil,1,1,S_DCHS5}
states[S_DCHS5] = {SPR_DCHS,TR_TRANS80|E,1,nil,1,1,S_DEATHSTATE}

//DROP DASH PAPERSPRITE

mobjinfo[MT_DDSP] = {
	doomednum = -1,
	spawnstate = S_DDSP,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_DDSP] = {SPR_DDSP,TR_TRANS20|FF_PAPERSPRITE,10,nil,2,2,S_DEATHSTATE}

//CUSTOM SMOKE/DUST
mobjinfo[MT_MSMO] = {
	doomednum = -1,
	spawnstate = S_MSMO,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MSMO] = {
	sprite = SPR_MSMO,
	tics = 6,
	frame = TR_TRANS40|A,
	nextstate = S_MSMO2
}

states[S_MSMO2] = {
	sprite = SPR_MSMO,
	tics = 4,
	frame = TR_TRANS60|A,
	nextstate = S_MSMO3
}

states[S_MSMO3] = {
	sprite = SPR_MSMO,
	tics = 2,
	frame = TR_TRANS80|A,
	nextstate = S_DEATHSTATE
}

//jump quake
mobjinfo[MT_JUPT] = {
	doomednum = -1,
	spawnstate = S_JUPT1,
	flags = MF_NOCLIP|MF_SCENERY
}
states[S_JUPT1] = {SPR_JUPT,FF_PAPERSPRITE|TR_TRANS10|A,1,nil,1,1,S_JUPT2}
states[S_JUPT2] = {SPR_JUPT,FF_PAPERSPRITE|TR_TRANS30|B,1,nil,1,1,S_JUPT3}
states[S_JUPT3] = {SPR_JUPT,FF_PAPERSPRITE|TR_TRANS50|C,1,nil,1,1,S_JUPT4}
states[S_JUPT4] = {SPR_JUPT,FF_PAPERSPRITE|TR_TRANS70|D,1,nil,1,1,S_JUPT5}
states[S_JUPT5] = {SPR_JUPT,FF_PAPERSPRITE|TR_TRANS90|E,1,nil,1,1,S_DEATHSTATE}

//STRONG HOMING ATTACK LINES
mobjinfo[MT_MHIT] = {
	doomednum = -1,
	spawnstate = S_MHIT,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MHIT] = {SPR_MHIT,TR_TRANS50|FF_ANIMATE,10,nil,2,2,S_DEATHSTATE}

mobjinfo[MT_MHTK] = {
	doomednum = -1,
	spawnstate = S_MHTK,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MHTK] = {SPR_MHTK,TR_TRANS20|FF_ANIMATE|A,1,nil,1,1,S_MHTK2}
states[S_MHTK2] = {SPR_MHTK,TR_TRANS40|FF_ANIMATE|B,1,nil,1,1,S_MHTK3}
states[S_MHTK3] = {SPR_MHTT,TR_TRANS60|FF_ANIMATE|C,1,nil,1,1,S_MHTK4}
states[S_MHTK4] = {SPR_MHTT,TR_TRANS80|FF_ANIMATE|A,2,nil,2,1,S_DEATHSTATE}

mobjinfo[MT_MHTKBIG] = {
	doomednum = -1,
	spawnstate = S_MHTKBIG,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MHTKBIG] = {SPR_MHTK,TR_TRANS80|FF_ANIMATE|A,1,nil,1,1,S_MHTKBIG2}
states[S_MHTKBIG2] = {SPR_MHTK,TR_TRANS60|FF_ANIMATE|B,1,nil,1,1,S_MHTKBIG3}
states[S_MHTKBIG3] = {SPR_MHTK,TR_TRANS40|FF_ANIMATE|C,1,nil,1,1,S_MHTKBIG4}
states[S_MHTKBIG4] = {SPR_MHTK,TR_TRANS20|FF_ANIMATE|A,1,nil,1,1,S_MHTKBIG5}
states[S_MHTKBIG5] = {SPR_MHTK,TR_TRANS40|FF_ANIMATE|B,1,nil,1,1,S_MHTKBIG6}
states[S_MHTKBIG6] = {SPR_MHTK,TR_TRANS60|FF_ANIMATE|C,1,nil,1,1,S_MHTKBIG7}
states[S_MHTKBIG7] = {SPR_MHTK,TR_TRANS80|FF_ANIMATE|A,1,nil,1,1,S_DEATHSTATE}

mobjinfo[MT_MJBK] = {
	doomednum = -1,
	spawnstate = S_MJBK,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MJBK] = {SPR_MJBK,TR_TRANS10,1,nil,1,1,S_MJBK2}
states[S_MJBK2] = {SPR_MJBK,TR_TRANS30,1,nil,1,1,S_MJBK3}
states[S_MJBK3] = {SPR_MJBK,TR_TRANS50,1,nil,1,1,S_MJBK4}
states[S_MJBK4] = {SPR_MJBK,TR_TRANS70,2,nil,2,1,S_DEATHSTATE}

mobjinfo[MT_MHTW] = {
	doomednum = -1,
	spawnstate = S_MHTW,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MHTW] = {
	sprite = SPR_MHTW,
	frame = TR_TRANS80|A,
	tics = 4,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_MHTS] = {
	doomednum = -1,
	spawnstate = S_MHTS,
	flags = MF_NOCLIP|MF_SCENERY
}

states[S_MHTS] = {
	sprite = SPR_MHTS,
	frame = TR_TRANS80|A,
	tics = 4,
	nextstate = S_DEATHSTATE
}


// effects and shit
/*local msondash_threshold = (3*TICRATE)
local msondash_max = (msondash_threshold + 3)
		
		if mo.player.dashmode >= msondash_threshold
			local fxmsonicBoom = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.eflags & MFE_VERTICALFLIP and mo.height - 32*mo.scale or 0), MT_MSSBOOM)
			fxmsonicBoom.angle = R_PointToAngle2(mo.x, mo.y, mo.player.x, mo.player.y)
			fxmsonicBoom.fuse = 2
			fxmsonicBoom.scale = $/2
			fxmsonicBoom.destscale = 1*FixedMul(player.speed, mo.scale)
			fxmsonicBoom.scalespeed = mo.scale/6
			fxmsonicBoom.eflags = mo.eflags & MFE_VERTICALFLIP
		end
		*/