if (NeoSonic != nil)
	// Multiple loaded?
	error("Neo Sonic was already loaded.");
	return;
end

// Define global table
rawset(_G, "NeoSonic", {});

dofile("neo_palettes.lua");
dofile("chengi_palettes.lua");

dofile("definitions.lua");

dofile("main.lua");
dofile("drop_dash.lua");
dofile("juicing.lua");
dofile("speed_share.lua");

addHook("PlayerThink", function(player)
	if not (player and player.valid and player.mo and player.mo.valid)
		return;
	end

	NeoSonic.AnimationThink(player);
	NeoSonic.MobjThinker(player.mo);
	NeoSonic.DropDashSwap(player);
	NeoSonic.DropDashThink(player);
	NeoSonic.Juicing(player);
	NeoSonic.DashShareThink(player);
end);
